// --------------------------------------------------------------------
// Copyright (c) 2005 by Terasic Technologies Inc. 
// --------------------------------------------------------------------
//
// Permission:
//
//   Terasic grants permission to use and modify this code for use
//   in synthesis for all Terasic Development Boards and Altera Development 
//   Kits made by Terasic.  Other use of this code, including the selling 
//   ,duplication, or modification of any portion is strictly prohibited.
//
// Disclaimer:
//
//   This VHDL/Verilog or C/C++ source code is intended as a design reference
//   which illustrates how these types of functions can be implemented.
//   It is the user's responsibility to verify their design for
//   consistency and functionality through the use of formal
//   verification methods.  Terasic provides no warranty regarding the use 
//   or functionality of this code.
//
// --------------------------------------------------------------------
//           
//                     Terasic Technologies Inc
//                     356 Fu-Shin E. Rd Sec. 1. JhuBei City,
//                     HsinChu County, Taiwan
//                     302
//
//                     web: http://www.terasic.com/
//                     email: support@terasic.com
//
// --------------------------------------------------------------------
//
// Major Functions:	DE0 LTM Module Display of Photo 
//
// --------------------------------------------------------------------
//
// Revision History :
// --------------------------------------------------------------------
//   Ver  :| Author            		:| Mod. Date :| Changes Made:
//   V1.0 :| Joe Yang,Johnny Fan	:| 07/03/30  :| Initial Revision
//   V1.1 :| ben                        :| 11/03/14  :| Quartus 10.1 sp1
// --------------------------------------------------------------------

module DE0_LTM_Ephoto
	(
		////////////////////	Clock Input	 	////////////////////	 
		////////////////////	Clock Input	 	////////////////////	 
		CLOCK_50,						//	50 MHz
		CLOCK_50_2,
		////////////////////	Push Button		////////////////////
		BUTTON,								//	Pushbutton[3:0]
		////////////////////	DPDT Switch		////////////////////
		SW,								//	Toggle Switch[17:0]
		////////////////////	7-SEG Dispaly	////////////////////
		HEX0_D,								//	Seven Segment Digit 0
		HEX0_DP,
		HEX1_D,								//	Seven Segment Digit 1
		HEX1_DP,
		HEX2_D,								//	Seven Segment Digit 2
		HEX2_DP,
		HEX3_D,								//	Seven Segment Digit 3
		HEX3_DP,
		////////////////////////	LED		////////////////////////
		LEDG,								//	LED Green[8:0]
		////////////////////////   LCD      ////////////////////////
		LCD_RW,                      // LCD Writr or Read select
		LCD_RS,                      // LCD Command or data select
		LCD_EN,                      // LCD Enable
		LCD_BLON,                    // LCD back Light ON/OFF
		LCD_DATA,                    // LCD DATA bus
		/////////////////////	SDRAM Interface		////////////////
		DRAM_DQ,							//	SDRAM Data bus 16 Bits
		DRAM_ADDR,						//	SDRAM Address bus 12 Bits
		DRAM_LDQM,						//	SDRAM Low-byte Data Mask 
		DRAM_UDQM,						//	SDRAM High-byte Data Mask
		DRAM_WE_N,						//	SDRAM Write Enable
		DRAM_CAS_N,						//	SDRAM Column Address Strobe
		DRAM_RAS_N,						//	SDRAM Row Address Strobe
		DRAM_CS_N,						//	SDRAM Chip Select
		DRAM_BA_0,						//	SDRAM Bank Address 0
		DRAM_BA_1,						//	SDRAM Bank Address 0
		DRAM_CLK,						//	SDRAM Clock
		DRAM_CKE,						//	SDRAM Clock Enable
		////////////////////	Flash Interface		////////////////
		FL_DQ,							//	FLASH Data bus 8 Bits
		FL_ADDR,							//	FLASH Address bus 22 Bits
		FL_ADDR_LSB,
		FL_WE_N,							//	FLASH Write Enable
		FL_RST_N,						//	FLASH Reset
		FL_OE_N,							//	FLASH Output Enable
		FL_CE_N,
		FL_BYTE_N,
	   //////////////////// UART     ////////////////////////////
		UART_TXD,			
		UART_RXD,
		////////////////////	SDCARD		////////////////////////////
		SD_WP_N,                   // SD Card write protect signal (active low)
      SD_CLK,                    // SD card clock
		SD_CMD,                    // SD card command signal
      SD_DAT0,                   // SD card data signal
		SD_DAT3,                   // SD card data signal
		////////////////////	PS2		////////////////////////////
      PS2_KBCLK,                 // PS/2 Clock
		PS2_KBDAT,                 // PS/2 Data
		PS2_MSCLK,                 // PS/2 Clock (reserved for second PS/2 device)
		PS2_MSDAT,                 // PS/2 Data(reserved for second PS/2 device)
		////////////////////	VGA		////////////////////////////
		VGA_HS,							//	VGA H_SYNC
		VGA_VS,							//	VGA V_SYNC
		VGA_R,   						//	VGA Red[9:0]
		VGA_G,	 						//	VGA Green[9:0]
		VGA_B,  							//	VGA Blue[9:0]
		////////////////////	GPIO	////////////////////////////
		GPIO0_CLKIN,					//	GPIO CLKIN
		GPIO0_CLKOUT,              // GPIO CLKOUT
		GPIO0_D,                   // GPIO DATA
		GPIO1_CLKIN,				   //	GPIO CLKIN
		GPIO1_CLKOUT,              // GPIO CLKOUT
		GPIO1_D                   // GPIO DATA
	);

////////////////////////	Clock Input	 	////////////////////////
input          CLOCK_50_2;          // 50 MHZ
input				CLOCK_50;				//	50 MHz
////////////////////////	Push Button		////////////////////////
input		[2:0]	BUTTON;						//	Pushbutton[3:0]
////////////////////////	DPDT Switch		////////////////////////
input		[9:0]SW;						//	Toggle Switch[17:0]
////////////////////////	7-SEG Dispaly	////////////////////////
output	[6:0]	HEX0_D;
output         HEX0_DP;					   //	Seven Segment Digit 0
output	[6:0]	HEX1_D;
output         HEX1_DP;						//	Seven Segment Digit 1
output	[6:0]	HEX2_D;
output         HEX2_DP;						//	Seven Segment Digit 2
output	[6:0]	HEX3_D;
output         HEX3_DP;						//	Seven Segment Digit 3
////////////////////////////	LED		////////////////////////////
output	[9:0]	LEDG;						//	LED Green[7:0]
///////////////////////////   LCD     /////////////////////////////
output         LCD_RW;                // LCD Write or read select
output         LCD_RS;                // LCD command or data select
output         LCD_EN;                // LCD Eable           
output         LCD_BLON;              // LCD BACK ON/OFF
output [7:0]   LCD_DATA;              // LCD DATA BUS
////////////////////////////	UART	////////////////////////////
output			UART_TXD;				//	UART Transmitter
input				UART_RXD;				//	UART Receiver
///////////////////////		SDRAM Interface	////////////////////////
inout	[15:0]	DRAM_DQ;					//	SDRAM Data bus 16 Bits
output[11:0]	DRAM_ADDR;				//	SDRAM Address bus 12 Bits
output			DRAM_LDQM;				//	SDRAM Low-byte Data Mask 
output			DRAM_UDQM;				//	SDRAM High-byte Data Mask
output			DRAM_WE_N;				//	SDRAM Write Enable
output			DRAM_CAS_N;				//	SDRAM Column Address Strobe
output			DRAM_RAS_N;				//	SDRAM Row Address Strobe
output			DRAM_CS_N;				//	SDRAM Chip Select
output			DRAM_BA_0;				//	SDRAM Bank Address 0
output			DRAM_BA_1;				//	SDRAM Bank Address 0
output			DRAM_CLK;				//	SDRAM Clock
output			DRAM_CKE;				//	SDRAM Clock Enable
////////////////////////	Flash Interface	////////////////////////
inout		[7:0]	FL_DQ;					//	FLASH Data bus 8 Bits
output	[21:0]FL_ADDR;					//	FLASH Address bus 22 Bits
output			FL_ADDR_LSB;
output			FL_WE_N;					//	FLASH Write Enable
output			FL_RST_N;				//	FLASH Reset
output			FL_OE_N;					//	FLASH Output Enable
output			FL_CE_N;					// FLASH CHIP ENABLE
output			FL_BYTE_N;				// FLASH BYTE MODE Enable
////////////////////////	SDCARD		////////////////////////////////
input          SD_CLK;              // SD Clock
inout          SD_CMD;              // SD Command bidirectional signal
inout          SD_DAT0;             // SD Data bidirectional signal
inout          SD_DAT3;             // SD Data bidirectional signal
output         SD_WP_N;             // SD Card write protect signal (active low)
////////////////////////	PS2		////////////////////////////////
inout       PS2_KBCLK;              // PS/2 Clock
inout		   PS2_KBDAT;              // PS/2 Data
inout 		PS2_MSCLK;              // PS/2 Clock (reserved for second PS/2 device)
inout  		PS2_MSDAT;			      // PS/2 Data(reserved for second PS/2 device)
////////////////////////	VGA			////////////////////////////
output			VGA_HS;					//	VGA H_SYNC
output			VGA_VS;					//	VGA V_SYNC
output	[3:0]	VGA_R;   				//	VGA Red[3:0]
output	[3:0]	VGA_G;	 				//	VGA Green[3:0]
output	[3:0]	VGA_B;   				//	VGA Blue[3:0]
////////////////////////	GPIO	////////////////////////////////
input	[1:0]	 GPIO0_CLKIN;
inout [1:0]	 GPIO0_CLKOUT;
inout [31:0] GPIO0_D;				//	GPIO Connection 0
input [1:0]  GPIO1_CLKIN;
inout [1:0]  GPIO1_CLKOUT;
inout	[31:0] GPIO1_D;					//	GPIO Connection 1

assign	LCD_ON		=	1'b0;
assign	LCD_BLON	=	1'b0;

assign   FL_BYTE_N = 1'b0;
//	All inout port turn to tri-state
assign   DRAM_DQ		= 16'hzzzz;
assign	OTG_DATA		 =	 16'hzzzz;
assign	LCD_DATA		 =	 8'hzz;
assign	SD_DAT		 =	 1'bz;
assign	ENET_DATA	 =	 16'hzzzz;
assign	AUD_ADCLRCK	 =	 1'bz;
assign	AUD_DACLRCK	 =	 1'bz;
assign	AUD_BCLK		 =	 1'bz;
assign   GPIO1_CLKOUT =  2'bzz;
assign   GPIO1_D      = 32'hzzzzzzzz;
//=============================================================================
// REG/WIRE declarations
//=============================================================================
// Touch panel signal //
wire	[7:0]	ltm_r;		//	LTM Red Data 8 Bits
wire	[7:0]	ltm_g;		//	LTM Green Data 8 Bits
wire	[7:0]	ltm_b;		//	LTM Blue Data 8 Bits
wire			ltm_nclk;	//	LTM Clcok
wire			ltm_hd;		
wire			ltm_vd;		
wire			ltm_den;
wire			ltm_grst;
// lcd 3wire interface//
wire			ltm_sclk;		
wire			ltm_sda;		
wire			ltm_scen;
wire 			ltm_3wirebusy_n;	
// Touch Screen Digitizer ADC	
wire 			adc_dclk;
wire 			adc_cs;
wire 			adc_penirq_n;
wire 			adc_busy;
wire 			adc_din;
wire 			adc_dout;
wire 			adc_ltm_sclk;		
   
wire	[11:0]x_coord;
wire	[11:0]y_coord;
wire			new_coord;	
reg 	[31:0]div;
wire	[2:0]	photo_cnt;
// clock
wire 			F_CLK;// flash read clock

// sdram to touch panel timing
wire			mRead;
wire	[15:0]Read_DATA1;
wire	[15:0]Read_DATA2;		
//  flash to sdram sdram
wire	[7:0] sRED;					// flash to sdram red pixel data		
wire	[7:0]	sGREEN;				// flash to sdram green pixel data
wire	[7:0]	sBLUE;				// flash to sdram blue pixel data
wire			sdram_write_en; 	// flash to sdram write control
wire			sdram_write; 		// sdram write signal
// system reset
wire			DLY0;
wire			DLY1;
wire			DLY2;
////////////// GPIO_O //////////////////
assign	adc_penirq_n  =GPIO0_CLKIN[0];
assign	adc_dout    =GPIO0_D[0];
assign	adc_busy    =GPIO0_CLKIN[1];
assign	GPIO0_D[1]	=adc_din;
assign	GPIO0_D[2]	=adc_ltm_sclk;
assign	GPIO0_D[3]	=ltm_b[3];
assign	GPIO0_D[4]	=ltm_b[2];
assign	GPIO0_D[5]	=ltm_b[1];
assign	GPIO0_D[6]	=ltm_b[0];
assign	GPIO0_D[7]	=ltm_nclk;
assign	GPIO0_D[8]	=ltm_den;
assign	GPIO0_D[9]	=ltm_hd;
assign	GPIO0_D[10]	=ltm_vd;
assign	GPIO0_D[11]	=ltm_b[4];
assign	GPIO0_D[12]	=ltm_b[5];
assign	GPIO0_D[13]	=ltm_b[6];
assign	GPIO0_CLKOUT[0]	=ltm_b[7];
assign	GPIO0_D[14]	=ltm_g[0];
assign	GPIO0_CLKOUT[1]	=ltm_g[1];
assign	GPIO0_D[15]	=ltm_g[2];
assign	GPIO0_D[16]	=ltm_g[3];
assign	GPIO0_D[17]	=ltm_g[4];
assign	GPIO0_D[18]	=ltm_g[5];
assign	GPIO0_D[19]	=ltm_g[6];
assign	GPIO0_D[20]	=ltm_g[7];
assign	GPIO0_D[21]	=ltm_r[0];
assign	GPIO0_D[22]	=ltm_r[1];
assign	GPIO0_D[23]	=ltm_r[2];
assign	GPIO0_D[24]	=ltm_r[3];
assign	GPIO0_D[25]	=ltm_r[4];
assign	GPIO0_D[26]	=ltm_r[5];
assign	GPIO0_D[27]	=ltm_r[6];
assign	GPIO0_D[28]	=ltm_r[7];
assign	GPIO0_D[29]	=ltm_grst;
assign	GPIO0_D[30]	=ltm_scen;
assign	GPIO0_D[31]	=ltm_sda;

assign adc_ltm_sclk	= ( adc_dclk & ltm_3wirebusy_n )  |  ( ~ltm_3wirebusy_n & ltm_sclk );
assign ltm_grst = BUTTON[0];
assign F_CLK 		= div[3];
//assign HEX0_D = Read_DATA1[6:0];
//assign HEX1_D = Read_DATA1[15:9];
//assign HEX2_D = Read_DATA2[6:0];
//assign HEX3_D = Read_DATA2[15:9];

//assign HEX0_D = x_coord[6:0];
//assign HEX1_D = x_coord[11:7];
//assign HEX2_D = y_coord[6:0];
//assign HEX3_D = y_coord[11:7];
//assign HEX0_D = ltm_r[7:1];
//assign HEX1_D = ltm_g[7:1];
//assign HEX2_D = ltm_b[7:1];
//assign HEX3_D = y_coord[11:7];
assign HEX0_DP=1'b1;
assign HEX1_DP=1'b1;
assign HEX2_DP=1'b0;
assign HEX3_DP=1'b1;
assign LEDG[9]=mRead;	//	LTM Clcok
assign LEDG[8]=photo_cnt[1];		
assign LEDG[7]=photo_cnt[0];		
assign LEDG[6]=new_coord;
assign LEDG[5]=adc_busy;
assign LEDG[4]=adc_din;
assign LEDG[3]=adc_dclk;
assign LEDG[2]=adc_dout;
assign LEDG[1]=adc_cs;
assign LEDG[0]=adc_penirq_n;

always @( posedge CLOCK_50 )
	begin
		div <= div+1;
	end	

///////////////////////////////////////////////////////////////
lcd_spi_cotroller    u1	   (	
							// Host Side
							.iCLK(CLOCK_50),
							.iRST_n(DLY0),
							// 3 wire Side
							.o3WIRE_SCLK(ltm_sclk),
							.io3WIRE_SDAT(ltm_sda),
							.o3WIRE_SCEN(ltm_scen),
							.o3WIRE_BUSY_n(ltm_3wirebusy_n)
							);	
							
adc_spi_controller	u2		(
							.iCLK(CLOCK_50),
							.iRST_n(DLY0),
							.oADC_DIN(adc_din),
							.oADC_DCLK(adc_dclk),
							.oADC_CS(adc_cs),
							.iADC_DOUT(adc_dout),
							.iADC_BUSY(adc_busy),
							.iADC_PENIRQ_n(adc_penirq_n),
							.oX_COORD(x_coord),
							.oY_COORD(y_coord),
							.oNEW_COORD(new_coord),
							 );

touch_point_detector	u3	(
							.iCLK(CLOCK_50),
							.iRST_n(DLY0),
							.iX_COORD(x_coord),
							.iY_COORD(y_coord),
							.iNEW_COORD(new_coord),
							.iSDRAM_WRITE_EN(sdram_write_en),
							.oPHOTO_CNT(photo_cnt),
							);

flash_to_sdram_controller 	u4	   (
							.iPHOTO_NUM(photo_cnt),
							.iRST_n(DLY1) ,
							.iF_CLK(F_CLK),
							.FL_DQ(FL_DQ)  ,				
							.oFL_ADDR({FL_ADDR,FL_ADDR_LSB}) ,			
							.oFL_WE_N(FL_WE_N) ,				
							.oFL_RST_n(FL_RST_N),			
							.oFL_OE_N(FL_OE_N) ,				
							.oFL_CE_N(FL_CE_N) ,				
							.oSDRAM_WRITE_EN(sdram_write_en),
							.oSDRAM_WRITE(sdram_write),
							.oRED(sRED),
							.oGREEN(sGREEN),
							.oBLUE(sBLUE),
							);


lcd_timing_controller	u5  ( 
							.iCLK(ltm_nclk),
							.iRST_n(DLY2),
							// sdram side
							.iREAD_DATA1(Read_DATA1[15:0]),
							.iREAD_DATA2(Read_DATA2[15:0]),
							.oREAD_SDRAM_EN(mRead),
							// lcd side
							.oLCD_R(ltm_r),
							.oLCD_G(ltm_g),
							.oLCD_B(ltm_b), 
							.oHD(ltm_hd),
							.oVD(ltm_vd),
							.oDEN(ltm_den)	
							);
							
//	SDRAM frame buffer
Sdram_Control_4Port	u6	(	//	HOST Side
						    .REF_CLK(CLOCK_50),
							.RESET_N(1'b1),
							//	FIFO Write Side 1
						    .WR1_DATA({sRED,sGREEN}),
							.WR1(sdram_write),
							.WR1_FULL(WR1_FULL),
							.WR1_ADDR(0),
							.WR1_MAX_ADDR(800*480),		
							.WR1_LENGTH(9'h80),
							.WR1_LOAD(!DLY0),
							.WR1_CLK(F_CLK),
							//	FIFO Write Side 2
							
						    .WR2_DATA({8'h0,sBLUE}),
							.WR2(sdram_write),
							.WR2_ADDR(22'h100000),
							.WR2_MAX_ADDR(22'h100000+800*480),
							.WR2_LENGTH(9'h80),
							.WR2_LOAD(!DLY0),
							.WR2_CLK(F_CLK),
							
							//	FIFO Read Side 1
						    .RD1_DATA(Read_DATA1),
				        	.RD1(mRead),
				        	.RD1_ADDR(0),			
							.RD1_MAX_ADDR(800*480),
							.RD1_LENGTH(9'h80),
				        	.RD1_LOAD(!DLY0),
							.RD1_CLK(ltm_nclk),
							//	FIFO Read Side 2
						   
							.RD2_DATA(Read_DATA2),
				        	.RD2(mRead),
							.RD2_ADDR(22'h100000),			
							.RD2_MAX_ADDR(22'h100000+800*480),
							.RD2_LENGTH(9'h80),
				        	.RD2_LOAD(!DLY0),
							.RD2_CLK(ltm_nclk),
							
							//	SDRAM Side
						    .SA(DRAM_ADDR),
						    .BA({DRAM_BA_1,DRAM_BA_0}),
						    .CS_N(DRAM_CS_N),
						    .CKE(DRAM_CKE),
						    .RAS_N(DRAM_RAS_N),
				            .CAS_N(DRAM_CAS_N),
				            .WE_N(DRAM_WE_N),
						    .DQ(DRAM_DQ),
				            .DQM({DRAM_UDQM,DRAM_LDQM}),
							.SDR_CLK(DRAM_CLK),
							.CLK_33(ltm_nclk)
								);
SEG7D2HEX u7 (
							.CLK(CLOCK_50),
							.RST(BUTTON[0]),
							.data(x_coord[7:3]),
							.nHEX0(HEX0_D)
								);
SEG7D2HEX u8 (
							.CLK(CLOCK_50),
							.RST(BUTTON[0]),
							.data(x_coord[11:8]),
							.nHEX0(HEX1_D)
								);
SEG7D2HEX u9 (
							.CLK(CLOCK_50),
							.RST(BUTTON[0]),
							.data(y_coord[7:3]),
							.nHEX0(HEX2_D)
								);
SEG7D2HEX u10 (
							.CLK(CLOCK_50),
							.RST(BUTTON[0]),
							.data(y_coord[11:8]),
							.nHEX0(HEX3_D)
								);

Reset_Delay			u11	   (.iCLK(CLOCK_50),
							.iRST(BUTTON[0]),
							.oRST_0(DLY0),
							.oRST_1(DLY1),
							.oRST_2(DLY2)
							);



endmodule